<?php
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
$login = $config['login'];
require_once 'user.interface.inc.php';
require_once "../vendor/autoload.php";

require_once 'bbb.inc.php';

$salon = $_GET['salon'] ?? "";
$action = $_POST['rejoindre'] ?? "";
$visio_ext = apcu_fetch('visio_ext');
$html = "";
$user = "";

use BigBlueButton\BigBlueButton;
use BigBlueButton\Parameters\IsMeetingRunningParameters;
use BigBlueButton\Parameters\JoinMeetingParameters;

if ((! empty($visio_ext[$salon])) && (! empty($action))) {
    $fullName = $_POST['fullName'] ?? "";
    $secret = $_POST['secret'] ?? "";
    $html .= SE4Logo();
    if ($secret != $visio_ext[$salon]['secret']) {
        $html .= "<b>Mot de passe invalide</b>";
    } elseif (empty($fullName)) {
        $html .= "<b>Indiquez votre Nom et votre Prénom</b>";
    } else {
        Joinconf($visio_ext, $fullName, $salon, $config);
    }
    $html .= '';
    $html .= HtmlJoinVisioForm();
} elseif (empty($salon)) { // pas de salon demandé
    $html .= SE4Logo() . '<b>Le salon n\'existe pas</b>';
} else {
    $user = search_user($config, $salon)['cn'];
    if (empty($user) || (is_eleve($config, $user))) { // ce n'est pas un user ou c'est un élève
        $html .= SE4Logo();
        $html .= "<b>Ce salon n'existe pas.</b>";
    } elseif (empty($visio_ext[$salon])) // le salon n'est pas encore créé
    {
        $html .= '  
                <img src="/elements/images/waitSE.gif" id="wait" alt="En attente d\'ouverture" />
                <b>
                <p>La réunion n\'a pas encore commencé.</p>
                Vous serez automatiquement connecté à la réunion, dès son démarrage.
                </b>';

        header("Refresh:15");
    } else {
        $html .= SE4Logo();
        $html .= HtmlJoinVisioForm();
    }
}

echo '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="../user/user.interface.login.css" />
                <title>Rejoindre une visioconférence</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                <!-- Tabs Titles -->
                <h2 class="active">Rejoindre une visioconférence</h2>
                ' . $html . '
                <div id="formFooter">
                  </p>
                </div>
              </div>
            </div>
        	</body>
        </html>
    ';

function HtmlJoinVisioForm()
{
    return '<!-- Login Form -->
        <form action="" method="post" >
        <input type="text" id="fullName" class="fadeIn second" name="fullName" placeholder="Prénom Nom">
        <input type="text" id="secret" class="fadeIn third" name="secret" placeholder="Mot de passe de la conférence">
        <input type="submit" class="fadeIn fourth" name="rejoindre" value="Rejoindre la visioconférence !">
        </form>';
}

function SE4Logo()
{
    return '<!-- SE4 image -->
        <div class="fadeIn first">
        <img src="/elements/images/LogoSambaEdu.png" id="icon" alt="Un service proposé par SambaÉdu" />
        </div>';
}

function Joinconf($visio_ext, $fullName, $salon, $config)
{
    curl_proxy_options($config, $curlopts);

    $bbb_list = config_bbb($config);
    $meeting_info = load_meeting_info($config, $bbb_list);

    $CPT = SearchKeyInMeetingInfo($meeting_info, $visio_ext[$salon]['meetingId']);
    /*
     * Vérifier que le meeting tourne ou l'effacer de $visio_ext
     * et revoyer la salle d'attente
     */
    if ($CPT == "-1") { // le meeting n'existe plus
        $visio_ext = apcu_fetch('visio_ext');
        unset($visio_ext[$salon]);
        apcu_store('visio_ext', $visio_ext, 240 * 60);
        header("Refresh:0");
    } else {
        $meetingName = $meeting_info[$CPT]['meetingName'];
        $meetingId = $meeting_info[$CPT]['meetingID'];
        $meetingServer = $meeting_info[$CPT]['server'];
        $attendeePW = $meeting_info[$CPT]['attendeePW'];
        $moderatorPW = $meeting_info[$CPT]['moderatorPW'];

        $key = array_search($meetingServer, array_column($bbb_list, "url"));

        // putenv("BBB_SECRET=" . $bbb_list[$key]['secret']);
        // putenv("BBB_SERVER_BASE_URL=" . $bbb_list[$key]['url']);

        $bbb = new BigBlueButton($bbb_list[$key]['url'], $bbb_list[$key]['secret'], $curlopts);

        $joinParams = new JoinMeetingParameters($meetingId, $fullName, $attendeePW);
        $joinParams->setRedirect(true);

        header('Status: 301 Moved Permanently', false, 301);
        header('Location:' . $bbb->getJoinMeetingURL($joinParams));
    }
}

function html_join_visio_form()
{
    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="../user/user.interface.login.css" />
                <title>Rejoindre une visioconférence</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                <!-- Tabs Titles -->
                <h2 class="active">Rejoindre une visioconférence</h2>
                <!-- Icon -->
                <div class="fadeIn first">
                  <img src="/elements/images/LogoSambaEdu.png" id="icon" alt="Un service proposé par SambaÉdu" />
                </div>
                <!-- Login Form -->
                <form action="" method="post" >
                  <input type="text" id="fullName" class="fadeIn second" name="fullName" placeholder="Prénom Nom">
                  <input type="text" id="secret" class="fadeIn third" name="secret" placeholder="Mot de passe de la conférence">
                  <input type="submit" class="fadeIn fourth" name="rejoindre" value="Rejoindre la visioconférence !">
                </form>
                <div id="formFooter">
                  </p>
                </div>
              </div>
            </div>
        	</body>
        </html>
    ';
    return $html;
}

function SearchKeyInMeetingInfo($table, $val)
{
    foreach ($table as $key => $row) {
        if ($row['meetingID'] == $val)
            return $key;
    }
    return - 1;
}

?>
